3 source /a
/bin
/errhandle
/err
5 echo 1 >~
/.local
/conflink
11 Usage: ${0##*/} [OPTIONS]
12 Link or otherwise install configuration files.
14 -f For fast. Dont use lnf, use ln -sf. Good for updating existing files.
26 lnf
() { /a
/exe
/lnf
"$@"; }
29 if [[ $1 == -f ]]; then # f for fast
34 echo "error: unrecognized arguments" >&2
39 lnf
() { ln -sf "$@"; }
46 # If we make a link back to the root, we stop going deeper into subdir_files.
47 # This makes it so we can do subdir directories. eg
48 # /p/c/subdir_files/.config/gajim -> ../../gagim
50 # Also note, under filesystem/, symlinks are expanded.
56 targets
=( "$2"/!(.git|..|.|.
#*) )
58 for f
in "$1"/!(.git|..|.|.
#*); do
59 if [[ -d $f ]]; then targets
+=("$f"); fi
63 below
="$( readlink -f "$root/..
")"
64 for path
in "${targets[@]}"; do
66 fullpath
="$(readlink -f "$path")"
67 if [[ -f $path || $
(dirname "$fullpath") == "$below" ]]; then
68 m lnf
-T "$path" "$HOME/${path#$root/}"
69 elif [[ -d "$path" ]]; then
70 subdir-link-r
"$root" "$path"
77 local dir fs x f reload_systemd
78 local -a reload_services
79 local -a restart_services
83 if [[ -e $fs && $user =~ ^iank?$
]]; then
84 cmd
=( s rsync
-aiSAX --chown=root
:root
--chmod=g-s
85 --exclude=/etc
/dovecot
/users
86 --exclude='/etc/exim4/passwd*'
87 --exclude='/etc/exim4/*.pem'
90 while read -r line
; do
97 restart_services
+=(dnsmasq
)
99 etc
/systemd
/resolved.conf.d
/*)
100 restart_services
+=(systemd-resolved
)
103 # Previously did this with tar, but it doesn't
104 # update directory permissions.
106 # S = do spare files efficiently
108 # X = preserve extended attributes
110 done < <("${cmd[@]}")
113 if [[ -e $dir/subdir_files
]]; then
114 m subdir-link-r
$dir/subdir_files
116 local x
=( $dir/!(binds|subdir_files|filesystem|machine_specific|..|.|.
#*) )
117 (( ${#x[@]} >= 1 )) ||
continue
120 if $reload_systemd; then
121 m s systemctl daemon-reload
123 for service
in ${restart_services[@]}; do
124 if systemctl is-active
$service >/dev
/null
; then
125 m s systemctl restart
$service
131 all_dirs
=({/a
/bin
/ds
,/p
/c
}{,/machine_specific
/$HOSTNAME})
132 # note, we assume a group of hosts does not have the
133 # same name as a single host, which is no problem on our scale.
134 for x
in /p
/c
/machine_specific
/*.hosts
/a
/bin
/ds
/machine_specific
/*.hosts
; do
135 if grep -qxF $HOSTNAME $x; then all_dirs
+=( ${x%.hosts} ); fi
139 for t
in systemstatus epanicclean btrfsmaintstop dynamicipupdate
; do
140 f
=/etc
/systemd
/system
/$t.timer
142 s systemctl stop
$t.timer
143 s systemctl disable
$t.timer
149 c_dirs
=(/a
/c
{,/machine_specific
/$HOSTNAME})
152 /a
/bin
/ds
/install-my-scripts
153 files
=(/p
/c
/machine_specific
/*/filesystem
/etc
/ssh
/*_key
154 /p
/c
/machine_specific
/*/filesystem
/etc
/openvpn
/client
/*.key
155 /p
/c
/filesystem
/etc
/openvpn
/client
/*.key
156 /p
/c
/filesystem
/etc
/openvpn
/easy-rsa
/keys
/*.key
158 if [[ -e ${files[0]} ]]; then
159 chmod 600 ${files[@]}
161 # p needs to go first so .ssh link is created, then config link inside it
162 m common-file-setup
${all_dirs[@]}
164 #### begin special extra stuff ####
165 install -d -m700 ~
/gpg-agent-socket
169 # reset to the original permissions.
173 sudo bash
-c 'shopt -s nullglob; for f in /etc/bind/*.key /etc/bind/*.private /etc/bind/key.*; do chgrp bind $f; done'
174 if [[ -e /etc
/caldav-htpasswd
]] && getent group www-data
&>/dev
/null
; then
175 s chgrp www-data
/etc
/caldav-htpasswd
177 if [[ -e /var
/lib
/znc
]] && getent group znc
; then
178 s chown
-R znc
:znc
/var
/lib
/znc
180 for f
in /etc
/prometheus-
{,export-
}htpasswd
; do
183 if getent passwd www-data
; then
184 s chown root
:www-data
$f
188 f
=/etc
/prometheus-pass
190 # note: this is duplicative of the file's own permissions
191 s
chmod 640 $f /etc
/prometheus-pass
192 if getent passwd prometheus
; then
193 s chown root
:prometheus
$f
198 ##### end special extra stuff #####
200 m sudo
-H -u user2
"${BASH_SOURCE[0]}"
202 f
=/a
/bin
/distro-setup
/system-status
207 echo 0 >~
/.local
/conflink
211 m common-file-setup
${c_dirs[@]}
214 echo "$0: error: unexpected user"; exit 1